function [Ebeta,Esigma,ETAU,n]=MCEM_Mies(T,theta_se,theta_mean,domain,ntime)
% The COVARIANCE matrix of theta is a full matrix (theta_se).
% The size of theta_se is person*(time*domain)^2, rather than
% person*(time*domain).
% This function is used to estimate intercept parameters, slope parameters,
% and residual in LGC model (Stage2) using MCEM algorithm with closed form
% in M-step.
% The size of beta is 2domain*1
[person,td]=size(theta_mean);  % td equals time*domain.
time=td/domain;
uno=2; indic=1; n=1;
SamNo=1000;
% The initial vector of parameters that need to be estimated.
new_beta=ones(domain,1)*[0;0.15]';
new_beta=new_beta(1:end)';  %(2domain)*1
new_TAU(1:2,1:2)=[0.2,0.1;0.1,0.2];
new_TAU(3:4,3:4)=[0.2,0.1;0.1,0.2];
new_sigma=0.15;
sam_theta=theta_mean;
Llike=@(i,beta,sigma,tau,thetaSE) mvnpdf(theta_mean(i,:)',T*beta,T*tau*T'+sigma*eye(td)+thetaSE);
for i=1:person
%     thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
    thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
    Llike0(i)=Llike(i,new_beta,new_sigma,new_TAU,thetaSE);
end
while indic==1 && n<ntime
    par_beta=new_beta;N_beta=zeros(1,2*domain);
    for m=1:SamNo
        % Importance sampling of theta and u.
        for i=1:person
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
            thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
            V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
            M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
            [r_u,p_u]=chol(V_u_random);
            V_u_random=r_u'*r_u;
            sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
            M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
            [r_theta,p_theta]=chol(V_theta);
            V_theta=r_theta'*r_theta;
            sam_theta(i,:)=mvnrnd(M_theta,V_theta);
       
        end
        clear i;
        N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2       
    end
    new_beta=(N_beta*inv(SamNo*person*T'*T))';
    
    par_sigma=new_sigma;
    D_sigma=0;
    for m=1:SamNo
        for i=1:person
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
            thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
            V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
            M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
            [r_u,p_u]=chol(V_u_random);
            V_u_random=r_u'*r_u;
            sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
            M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
            [r_theta,p_theta]=chol(V_theta);
            V_theta=r_theta'*r_theta;
            sam_theta(i,:)=mvnrnd(M_theta,V_theta);
            
            D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
        end
        clear i;      
    end
    new_sigma=D_sigma/(SamNo*td*person);
    clear D_sigma

    par_TAU=new_TAU;
    N_TAU=zeros(domain*2,domain*2);
    for m=1:SamNo
        % Importance sampling of theta and u.
        for i=1:person
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
            thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
            V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
            M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
            [r_u,p_u]=chol(V_u_random);
            V_u_random=r_u'*r_u;
            sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
            N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
        end
        clear i;      
    end
    new_TAU=N_TAU/(SamNo*person);
    new_TAU(1:domain,domain+1:2*domain)=0;
    new_TAU(domain+1:2*domain,1:domain)=0;
    new_TAUp=zeros(1,6);
    new_TAUp(1:2)=new_TAU(1,1:2);new_TAUp(1,3)=new_TAU(2,2);new_TAUp(1,4:5)=new_TAU(3,3:4);new_TAUp(1,6)=new_TAU(4,4); 
    
    for i=1:person
%         thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
        thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
        Llike1(i)=Llike(i,new_beta,new_sigma,new_TAU,thetaSE);
    end
    
    if abs(sum(log(Llike1))-sum(log(Llike0)))<0.005 %It's hard to converge if use 0.001.
%         max(abs(new_beta-par_beta))+abs(new_sigma-par_sigma)+max(abs(new_TAU(1:end)-par_TAU(1:end)))<0.001       
%         norm(new_beta-par_beta,2)+abs(new_sigma-par_sigma)+norm(new_TAU(1:end)-par_TAU(1:end),2)<0.008    
        indic=0;
    else n=n+1;
        Llike0=Llike1;
    end
end
Ebeta=new_beta;
Esigma=new_sigma; 
ETAU=new_TAU; 
