function[Ese]=MCEM_Mies_se(T,Ebeta,Esigma,ETAU,theta_mean,theta_se)
%This function is used to estimate the standard error using MCEM algorithm.
[person,td]=size(theta_mean);  % td equals time*domain.
domain=length(Ebeta)/2;
SamNo=1000;
sam_theta=theta_mean;
new_beta=Ebeta;new_sigma=Esigma;new_TAU=ETAU;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%         Step 2: Standard Error.         %%%%%%%%%%%
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU(1,1:2);new_TAUp(3)=new_TAU(2,2);new_TAUp(1,4:5)=new_TAU(3,3:4);new_TAUp(6)=new_TAU(4,4); 
hat=[new_beta' new_sigma new_TAUp]; %1*11

%%%Some matrices are used to calculate the second-order %%%%%%%
Tmatrix(:,:,1)=[1 0 0 0;0 0 0 0;0 0 0 0;0 0 0 0];
Tmatrix(:,:,2)=[0 1 0 0;1 0 0 0;0 0 0 0;0 0 0 0];
Tmatrix(:,:,3)=[0 0 0 0;0 1 0 0;0 0 0 0;0 0 0 0];
Tmatrix(:,:,4)=[0 0 0 0;0 0 0 0;0 0 1 0;0 0 0 0];
Tmatrix(:,:,5)=[0 0 0 0;0 0 0 0;0 0 0 1;0 0 1 0];
Tmatrix(:,:,6)=[0 0 0 0;0 0 0 0;0 0 0 0;0 0 0 1];
D2tau=@(p,q,u) -trace(inv(new_TAU)*Tmatrix(:,:,q)*inv(new_TAU)*Tmatrix(:,:,p))/2-u'*inv(new_TAU)*(Tmatrix(:,:,p)*inv(new_TAU)*Tmatrix(:,:,q)+Tmatrix(:,:,q)*inv(new_TAU)*Tmatrix(:,:,p))*inv(new_TAU)*u/2;

%%%% 2-order derivative of full likelihood
D2BETA=@(th,u) -T'*(new_sigma^(-1)*eye(td))*T;
D2SIGMA=@(th,u) td*new_sigma^(-2)/2-(th'-T*new_beta-T*u)'*(new_sigma^(-3)*eye(td))*(th'-T*new_beta-T*u);
D2BS=@(th,u) -(th'-T*new_beta-T*u)'*(new_sigma^(-2)*eye(td))*T;
D2_beta=zeros(4,4); D2_sigma=0; D2_bs=zeros(1,4); 
D2_tau11=0;D2_tau12=0;D2_tau13=0;D2_tau22=0;D2_tau23=0;D2_tau33=0;
D2_tau44=0;D2_tau45=0;D2_tau46=0;D2_tau55=0;D2_tau56=0;D2_tau66=0;
for i=1:person     
        for s=1:SamNo           
            %%% Importance sampling of theta and u_random.
%             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
            thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
            V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
            M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
            [r_u,p_u]=chol(V_u_random);
            V_u_random=r_u'*r_u;
            sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
            M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
            [r_theta,p_theta]=chol(V_theta);
            V_theta=r_theta'*r_theta;
            sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                                    
            D2_beta=D2_beta+D2BETA(sam_theta(i,:),sam_u_random(:,i));
            D2_sigma=D2_sigma+D2SIGMA(sam_theta(i,:),sam_u_random(:,i));
            D2_bs=D2_bs+D2BS(sam_theta(i,:),sam_u_random(:,i));
            
            D2_tau11=D2_tau11+D2tau(1,1,sam_u_random(:,i));
            D2_tau22=D2_tau22+D2tau(2,2,sam_u_random(:,i));
            D2_tau33=D2_tau33+D2tau(3,3,sam_u_random(:,i));
            D2_tau44=D2_tau44+D2tau(4,4,sam_u_random(:,i));
            D2_tau55=D2_tau55+D2tau(5,5,sam_u_random(:,i));
            D2_tau66=D2_tau66+D2tau(6,6,sam_u_random(:,i));
            
            D2_tau12=D2_tau12+D2tau(1,2,sam_u_random(:,i));
            D2_tau13=D2_tau13+D2tau(1,3,sam_u_random(:,i));
            D2_tau23=D2_tau23+D2tau(2,3,sam_u_random(:,i));
            D2_tau45=D2_tau45+D2tau(4,5,sam_u_random(:,i));
            D2_tau46=D2_tau46+D2tau(4,6,sam_u_random(:,i));
            D2_tau56=D2_tau56+D2tau(5,6,sam_u_random(:,i));
            
        end        
end
FisherM=zeros(11,11);
FisherM(1:4,1:4)=D2_beta;
FisherM(5,1:4)=D2_bs;  
FisherM(1:4,5)=D2_bs'; 
FisherM(5,5)=D2_sigma;
FisherM(6,6:8)=[D2_tau11 D2_tau12 D2_tau13];
FisherM(6:8,6)=[D2_tau11;D2_tau12;D2_tau13];
FisherM(7,6:8)=[D2_tau12 D2_tau22 D2_tau23];
FisherM(6:8,7)=[D2_tau12;D2_tau22;D2_tau23];
FisherM(8,6:8)=[D2_tau13 D2_tau23 D2_tau33];
FisherM(6:8,8)=[D2_tau13;D2_tau23;D2_tau33];
FisherM(9,9:11)=[D2_tau44 D2_tau45 D2_tau46];
FisherM(9:11,9)=[D2_tau44;D2_tau45;D2_tau46];
FisherM(10,9:11)=[D2_tau45 D2_tau55 D2_tau56];
FisherM(9:11,10)=[D2_tau45;D2_tau55;D2_tau56];
FisherM(11,9:11)=[D2_tau46 D2_tau56 D2_tau66];
FisherM(9:11,11)=[D2_tau46;D2_tau56;D2_tau66];

FisherM=-FisherM/SamNo;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Part II --- FDM. Refer to Tian, Cai, Thissen & Xin (2012)
eta=1;  % four levels: 1 10e-3 10e-5 10e-7
new_delta=zeros(11,11);
clear new_beta new_sigma new_TAU
  
delta=new_delta;
new_beta=[Ebeta(1)+eta;Ebeta(2:end)];new_sigma=Esigma;new_TAU=ETAU;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPbeta1=[new_beta_map' new_sigma_map new_TAUp];   %1*11 

new_delta(1,:)=(MAPbeta1-hat)./eta;   % Update each raw of Delta matrix.
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map new_TAUp
%%%%%%%%%%%%%%%%%%%%%%% beta_2 part
delta=new_delta;
new_beta=[Ebeta(1);Ebeta(2)+eta;Ebeta(3:end)];new_sigma=Esigma;new_TAU=ETAU;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
 end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPbeta2=[new_beta_map' new_sigma_map new_TAUp]; 

new_delta(2,:)=(MAPbeta2-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%%%%%%%% beta_3 part
delta=new_delta;
new_beta=[Ebeta(1:2);Ebeta(3)+eta;Ebeta(end)];new_sigma=Esigma;new_TAU=ETAU;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPbeta3=[new_beta_map' new_sigma_map new_TAUp];

new_delta(3,:)=(MAPbeta3-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%%%%%%%%%%% beta_4 part
delta=new_delta;
new_beta=[Ebeta(1:3);Ebeta(end)+eta];new_sigma=Esigma;new_TAU=ETAU;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPbeta4=[new_beta_map' new_sigma_map new_TAUp];

new_delta(4,:)=(MAPbeta4-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%%%%% sigma part
delta=new_delta;
new_beta=Ebeta;new_sigma=Esigma+eta;new_TAU=ETAU;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPsigma=[new_beta_map' new_sigma_map new_TAUp];

new_delta(5,:)=(MAPsigma-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%% tau_1 part
delta=new_delta;
eta_temp=zeros(4,4); eta_temp(1,1)=eta;
new_beta=Ebeta;new_sigma=Esigma;new_TAU=ETAU+eta_temp;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPtau1=[new_beta_map' new_sigma_map new_TAUp];

new_delta(6,:)=(MAPtau1-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%% tau_2 part
delta=new_delta;
eta_temp=zeros(4,4); eta_temp(1,2)=eta;eta_temp(2,1)=eta;
new_beta=Ebeta;new_sigma=Esigma;new_TAU=ETAU+eta_temp;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPtau2=[new_beta_map' new_sigma_map new_TAUp];

new_delta(7,:)=(MAPtau2-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%% tau_3 part
delta=new_delta;
eta_temp=zeros(4,4); eta_temp(2,2)=eta;
new_beta=Ebeta;new_sigma=Esigma;new_TAU=ETAU+eta_temp;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPtau3=[new_beta_map' new_sigma_map new_TAUp];

new_delta(8,:)=(MAPtau3-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%% tau_4 part
delta=new_delta;
eta_temp=zeros(4,4); eta_temp(3,3)=eta;
new_beta=Ebeta;new_sigma=Esigma;new_TAU=ETAU+eta_temp;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPtau4=[new_beta_map' new_sigma_map new_TAUp];

new_delta(9,:)=(MAPtau4-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%% tau_5 part
delta=new_delta;
eta_temp=zeros(4,4); eta_temp(3,4)=eta;eta_temp(4,3)=eta;
new_beta=Ebeta;new_sigma=Esigma;new_TAU=ETAU+eta_temp;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPtau5=[new_beta_map' new_sigma_map new_TAUp];

new_delta(10,:)=(MAPtau5-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
%%%%%%%%%%% tau_4 part
delta=new_delta;
eta_temp=zeros(4,4); eta_temp(4,4)=eta;
new_beta=Ebeta;new_sigma=Esigma;new_TAU=ETAU+eta_temp;
N_beta=zeros(1,2*domain);
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
             end
             clear i;
             N_beta=N_beta+sum((sam_theta'-T*sam_u_random)'*T,1);  %1*2
end
 new_beta_map=(N_beta*inv(SamNo*person*T'*T))';
                 
D_sigma=0;
for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
                 M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
                 [r_theta,p_theta]=chol(V_theta);
                 V_theta=r_theta'*r_theta;
                 sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                 D_sigma=D_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));
             end
             clear i;
end
 new_sigma_map=D_sigma/(SamNo*td*person);
 clear D_sigma
         
N_TAU=zeros(domain*2,domain*2);
 for m=1:SamNo
             for i=1:person
                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                 %             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
                 thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
                 V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
                 M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
                 [r_u,p_u]=chol(V_u_random);
                 V_u_random=r_u'*r_u;
                 sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
                 N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';
             end
             clear i;
 end
 new_TAU_map=N_TAU/(SamNo*person);
new_TAU_map(1:domain,domain+1:2*domain)=0;new_TAU_map(domain+1:2*domain,1:domain)=0;
new_TAUp=zeros(1,6);
new_TAUp(1:2)=new_TAU_map(1,1:2);new_TAUp(3)=new_TAU_map(2,2);new_TAUp(1,4:5)=new_TAU_map(3,3:4);new_TAUp(6)=new_TAU_map(4,4); 
MAPtau6=[new_beta_map' new_sigma_map new_TAUp];

new_delta(11,:)=(MAPtau6-hat)./eta;
clear new_beta new_sigma new_TAU new_beta_map new_sigma_map new_TAU_map  new_TAUp
delta=new_delta;

covariance=inv(FisherM)*inv(eye(11)-delta);
se=sqrt(diag(covariance));
Ese=se; 