function [rbeta,rTAU,rsigma,rPI,rth]=MCMC_MPLFIX(u,T,ntime,b,a,c)
% This function is used to estimate all the parameters in longitudinal IRT
% model (IRT with LGC) when item parameters are fixed.
[person,item,time]=size(u);
domain=size(a,1);
J=item/domain;
for d=1:domain
    Dind(d,(d-1)*J+1:d*J)=ones(1,J);  % indicator of dimension
end
clear d
% The initial vector of parameters that need to be estimated.
theta=0.5*ones(person,domain*time);
PI=zeros(person,2*domain);
TAU=100*eye(2*domain);
beta=zeros(2*domain,1);
sigma=100;
% The prior information of beta and TAU.
prior=zeros(2+4*domain,2+4*domain);
prior(1:2*domain,1)=zeros(2*domain,1);
prior(2*domain+1,2*domain+1)=0;
prior(2*domain+2,2*domain+2)=-1;
prior(2*domain+3:end,2*domain+3:end)=eye(2*domain);

if nargin<6
    c=zeros(time,item);
end

for i=1:ntime  
    [beta,TAU]=norInvW_M(prior,PI);
    rbeta(:,i)=beta;
    rTAU(i,:)=TAU(1:end);
    
    PI=mvnPIpost(sigma,T,TAU,theta,beta);
    rPI(:,:,i)=PI;   
    
    sigma=invG(T,person,theta,PI);
    rsigma(i)=sigma;
    
    theta=mh_partMFIX(u,PI,T,sigma,theta,b,a,c); 
    rth(:,:,i)=theta;  
end    



