function [Ebeta,Esigma,ETAU,Ese,n]=MCMLE_Mies(T,theta_se,theta_mean,domain,ntime)
% This function is used to estimate intercept parameters, slope parameters,
% and residual in LGC model (Stage2) using MCMLE algorithm with closed form.
% The size of beta is 2*1
[person,td]=size(theta_mean);  % td equals time*domain.
uno=2;  % The number of random effect coefficients.
SamNo=1000; % The number of quadrature points.
indic=1; n=0; 
% The initial vector of parameters that need to be estimated.
new_beta=ones(domain,1)*[0;0.15]';
new_beta=new_beta(1:end)';  %(2domain)*1
new_sigma=0.15;
% new_TAU=0.2*eye(domain*2);
new_TAU(1:2,1:2)=[0.2,0.1;0.1,0.2];
new_TAU(3:4,3:4)=[0.2,0.1;0.1,0.2];
sam_theta=theta_mean;
Llike=@(i,beta,sigma,tau,thetaSE) mvnpdf(theta_mean(i,:)',T*beta,T*tau*T'+sigma*eye(td)+thetaSE);
for i=1:person
%     thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
    thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
    Llike0(i)=Llike(i,new_beta,new_sigma,new_TAU,thetaSE);
end
while indic==1 && n<ntime
    par_beta=new_beta;
    N_beta=zeros(1,uno*domain); D_beta=zeros(uno*domain,uno*domain);
    for i=1:person
        for m=1:SamNo
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
            thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
            V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
            M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
            [r_u,p_u]=chol(V_u_random);
            V_u_random=r_u'*r_u;
            sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
            M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
            [r_theta,p_theta]=chol(V_theta);
            V_theta=r_theta'*r_theta;
            sam_theta(i,:)=mvnrnd(M_theta,V_theta);
            
            N_beta=N_beta+(sam_theta(i,:)'-T*sam_u_random(:,i))'*T;                   
        end 
        D_beta=D_beta+T'*T;       
    end
    new_beta=(N_beta*inv(D_beta)/SamNo)';
    
    par_sigma=new_sigma;
    N_sigma=0; 
    for i=1:person
        for m=1:SamNo
           %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
            thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
            V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
            M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
            [r_u,p_u]=chol(V_u_random);
            V_u_random=r_u'*r_u;
            sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
            M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
            [r_theta,p_theta]=chol(V_theta);
            V_theta=r_theta'*r_theta;
            sam_theta(i,:)=mvnrnd(M_theta,V_theta);
            
            N_sigma=N_sigma+(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i))'*(sam_theta(i,:)'-T*new_beta-T*sam_u_random(:,i));        
        end       
    end
    new_sigma=N_sigma/(person*td*SamNo);    

     N_TAU=zeros(2*domain,2*domain);
     par_TAU=new_TAU;
    for i=1:person
        for m=1:SamNo
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
            thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
            V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
            M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
            [r_u,p_u]=chol(V_u_random);
            V_u_random=r_u'*r_u;
            sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
            M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
            [r_theta,p_theta]=chol(V_theta);
            V_theta=r_theta'*r_theta;
            sam_theta(i,:)=mvnrnd(M_theta,V_theta);
            
            N_TAU=N_TAU+sam_u_random(:,i)*sam_u_random(:,i)';         
        end     
    end
    new_TAU=N_TAU/(person*SamNo);
    new_TAU(1:domain,domain+1:2*domain)=0;
    new_TAU(domain+1:2*domain,1:domain)=0;
   
    for i=1:person
%         thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
        thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
        Llike1(i)=Llike(i,new_beta,new_sigma,new_TAU,thetaSE);
    end
    
    if abs(sum(log(Llike1))-sum(log(Llike0)))<0.005
%         max(abs(new_beta-par_beta))+abs(new_sigma-par_sigma)+max(abs(new_TAU(1:end)-par_TAU(1:end)))<0.005
%         norm(new_beta-par_beta,2)+abs(new_sigma-par_sigma)+norm(new_TAU(1:end)-par_TAU(1:end),2)<0.008                                                      
        indic=0;
    else n=n+1;
        Llike0=Llike1;
    end
    
end

Ebeta=new_beta;
Esigma=new_sigma; 
ETAU=new_TAU;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%         Step 2: Standard Error.         %%%%%%%%%%%
detTAU0=det(new_TAU(1:2,1:2)); detTAU1=det(new_TAU(3:4,3:4));
tau1=new_TAU(1,1);tau2=new_TAU(1,2);tau3=new_TAU(2,2);tau4=new_TAU(3,3);tau5=new_TAU(3,4);tau6=new_TAU(4,4);
%%%Some matrices are used to calculate the second-order %%%%%%%
%%% 1-order derivative of full likelihood r.w.t. TAU.   %%%%%%%
Tmatrix1=[-tau3^2 tau2*tau3 0 0; tau2*tau3 -tau2^2 0 0;zeros(2,4)];
Tmatrix2=[2*tau2*tau3 -tau1*tau3-tau2^2 0 0;-tau1*tau3-tau2^2 2*tau1*tau2 0 0;zeros(2,4)];
Tmatrix3=[-tau2^2 tau1*tau2 0 0; tau1*tau2 -tau1^2 0 0;zeros(2,4)];
Tmatrix4=[zeros(2,4); 0 0 -tau6^2 tau5*tau6;0 0 tau5*tau6 -tau5^2];
Tmatrix5=[zeros(2,4); 0 0 2*tau5*tau6 -tau4*tau6-tau5^2;0 0 -tau4*tau6-tau5^2 2*tau4*tau5];
Tmatrix6=[zeros(2,4); 0 0 -tau5^2 tau4*tau5;0 0 tau4*tau5 -tau4^2];
%%% 2-order derivative of full likelihood r.w.t. TAU.   %%%%%%%
Tmatrix11=[tau3^3 -tau2*tau3^2 0 0;-tau2*tau3^2 tau2^2*tau3 0 0;zeros(2,4)];
Tmatrix22=[tau1*tau3^2+3*tau2^2*tau3 -tau2^3-3*tau1*tau2*tau3 0 0;-tau2^3-3*tau1*tau2*tau3 tau1^2*tau3+3*tau1*tau2^2 0 0;zeros(2,4)];
Tmatrix33=[tau1*tau2^2 -tau1^2*tau2 0 0;-tau1^2*tau2 tau1^3 0 0;zeros(2,4)];
Tmatrix12=[-4*tau2*tau3^2 tau1*tau3^2+3*tau2^2*tau3 0 0;tau1*tau3^2+3*tau2^2*tau3 -2*tau1*tau2*tau3-2*tau2^3 0 0;zeros(2,4)];
Tmatrix13=[2*tau2^2*tau3 -tau1*tau2*tau3-tau2^3 0 0;-tau1*tau2*tau3-tau2^3 2*tau1*tau2^2 0 0;zeros(2,4)];
Tmatrix23=[-2*tau1*tau2*tau3-2*tau2^3 tau1^2*tau3+3*tau1*tau2^2 0 0;tau1^2*tau3+3*tau1*tau2^2 -4*tau1^2*tau2 0 0;zeros(2,4)];
%%% 2-order derivative of full likelihood r.w.t. TAU.   %%%%%%%
Tmatrix44=[zeros(2,4); 0 0 tau6^3 -tau5*tau6^2;0 0 -tau5*tau6^2 tau5^2*tau6];
Tmatrix55=[zeros(2,4); 0 0 tau4*tau6^2+3*tau5^2*tau6 -tau5^3-3*tau4*tau5*tau6;0 0 -tau5^3-3*tau4*tau5*tau6 tau4^2*tau6+3*tau4*tau5^2];
Tmatrix66=[zeros(2,4); 0 0 tau4*tau5^2 -tau4^2*tau5;0 0 -tau4^2*tau5 tau4^3];
Tmatrix45=[zeros(2,4); 0 0 -4*tau5*tau6^2 tau4*tau6^2+3*tau5^2*tau6;0 0 tau4*tau6^2+3*tau5^2*tau6 -2*tau4*tau5*tau6-2*tau5^3];
Tmatrix46=[zeros(2,4); 0 0 2*tau5^2*tau6 -tau4*tau5*tau6-tau5^3;0 0 -tau4*tau5*tau6-tau5^3 2*tau4*tau5^2];
Tmatrix56=[zeros(2,4); 0 0 -2*tau4*tau5*tau6-2*tau5^3 tau4^2*tau6+3*tau4*tau5^2;0 0 tau4^2*tau6+3*tau4*tau5^2 -4*tau4^2*tau5];


D1BETA=@(th,u) (th'-T*new_beta-T*u)'*(new_sigma^(-1)*eye(td))*T;
D1SIGMA=@(th,u) (-td*new_sigma^(-1)+(th'-T*new_beta-T*u)'*(new_sigma^(-2)*eye(td))*(th'-T*new_beta-T*u))/2;
D1TAU1=@(th,u) -tau3/(2*detTAU0)-u'*Tmatrix1*u/(2*detTAU0^2);
D1TAU2=@(th,u) tau2/detTAU0-u'*Tmatrix2*u/(2*detTAU0^2);
D1TAU3=@(th,u) -tau1/(2*detTAU0)-u'*Tmatrix3*u/(2*detTAU0^2);
D1TAU4=@(th,u) -tau6/(2*detTAU0)-u'*Tmatrix4*u/(2*detTAU1^2);
D1TAU5=@(th,u) tau5/detTAU0-u'*Tmatrix5*u/(2*detTAU1^2);
D1TAU6=@(th,u) -tau4/(2*detTAU0)-u'*Tmatrix6*u/(2*detTAU1^2);

D2BETA=@(th,u) ((th'-T*new_beta-T*u)'*(new_sigma^(-1)*eye(td))*(T*T')*(new_sigma^(-1)*eye(td))*(th'-T*new_beta-T*u)-T'*(new_sigma^(-1)*eye(td))*T);  
D2SIGMA=@(th,u) ((-td*new_sigma^(-1)+(th'-T*new_beta-T*u)'*(new_sigma^(-2)*eye(td))*(th'-T*new_beta-T*u)).^2/2+td*new_sigma^(-2)-2*(th'-T*new_beta-T*u)'*(new_sigma^(-3)*eye(td))*(th'-T*new_beta-T*u))/2;
D2BS=@(th,u) (-td*new_sigma^(-1)+(th'-T*new_beta-T*u)'*(new_sigma^(-2)*eye(td))*(th'-T*new_beta-T*u))*(th'-T*new_beta-T*u)'*(new_sigma^(-1)*eye(td))*T/2-(th'-T*new_beta-T*u)'*(new_sigma^(-2)*eye(td))*T;  %1*2
D2TAU11=@(th,u) D1TAU1(th,u)^2+tau3^2/(2*detTAU0^2)-u'*Tmatrix11*u/(detTAU0^3);
D2TAU22=@(th,u) D1TAU2(th,u)^2+(tau1*tau3+tau2^2)/(detTAU0^2)-u'*Tmatrix22*u/(detTAU0^3);
D2TAU33=@(th,u) D1TAU3(th,u)^2+tau1^2/(2*detTAU0^2)-u'*Tmatrix33*u/(detTAU0^3);
D2TAU12=@(th,u) D1TAU1(th,u)*D1TAU2(th,u)-tau2*tau3/(detTAU0^2)-u'*Tmatrix12*u/(2*detTAU0^3);
D2TAU13=@(th,u) D1TAU1(th,u)*D1TAU3(th,u)+tau2^2/(2*detTAU0^2)-u'*Tmatrix13*u/(2*detTAU0^3);
D2TAU23=@(th,u) D1TAU2(th,u)*D1TAU3(th,u)-tau1*tau2/(detTAU0^2)-u'*Tmatrix23*u/(2*detTAU0^3);
D2TAU44=@(th,u) D1TAU4(th,u)^2+tau6^2/(2*detTAU1^2)-u'*Tmatrix44*u/(detTAU1^3);
D2TAU55=@(th,u) D1TAU5(th,u)^2+(tau4*tau6+tau5^2)/(detTAU1^2)-u'*Tmatrix55*u/(detTAU1^3);
D2TAU66=@(th,u) D1TAU6(th,u)^2+tau4^2/(2*detTAU1^2)-u'*Tmatrix66*u/(detTAU1^3);
D2TAU45=@(th,u) D1TAU4(th,u)*D1TAU5(th,u)-tau5*tau6/(detTAU1^2)-u'*Tmatrix45*u/(2*detTAU1^3);
D2TAU46=@(th,u) D1TAU4(th,u)*D1TAU6(th,u)+tau5^2/(2*detTAU1^2)-u'*Tmatrix46*u/(2*detTAU1^3);
D2TAU56=@(th,u) D1TAU5(th,u)*D1TAU6(th,u)-tau4*tau5/(detTAU1^2)-u'*Tmatrix56*u/(2*detTAU1^3);

D2BT1=@(th,u) D1BETA(th,u)*D1TAU1(th,u);
D2BT2=@(th,u) D1BETA(th,u)*D1TAU2(th,u);
D2BT3=@(th,u) D1BETA(th,u)*D1TAU3(th,u);
D2BT4=@(th,u) D1BETA(th,u)*D1TAU4(th,u);
D2BT5=@(th,u) D1BETA(th,u)*D1TAU5(th,u);
D2BT6=@(th,u) D1BETA(th,u)*D1TAU6(th,u);
D2ST1=@(th,u) D1SIGMA(th,u)*D1TAU1(th,u);
D2ST2=@(th,u) D1SIGMA(th,u)*D1TAU2(th,u);
D2ST3=@(th,u) D1SIGMA(th,u)*D1TAU3(th,u);
D2ST4=@(th,u) D1SIGMA(th,u)*D1TAU4(th,u);
D2ST5=@(th,u) D1SIGMA(th,u)*D1TAU5(th,u);
D2ST6=@(th,u) D1SIGMA(th,u)*D1TAU6(th,u);

D2_beta=zeros(4,4); D2_sigma=0; D2_bs=zeros(1,4); 
D2_bt1=zeros(1,4); D2_bt2=zeros(1,4); D2_bt3=zeros(1,4);D2_bt4=zeros(1,4); D2_bt5=zeros(1,4); D2_bt6=zeros(1,4);
D2_st1=0; D2_st2=0; D2_st3=0;D2_st4=0; D2_st5=0; D2_st6=0;
D2_tau11=0;D2_tau12=0;D2_tau13=0;D2_tau22=0;D2_tau23=0;D2_tau33=0;
D2_tau44=0;D2_tau45=0;D2_tau46=0;D2_tau55=0;D2_tau56=0;D2_tau66=0;
D1_beta=zeros(1,4); D1_sigma=0;
D1_tau1=0;D1_tau2=0;D1_tau3=0;D1_tau4=0;D1_tau5=0;D1_tau6=0;
VarMatrix=-eye(11);
wn=1;
while sum(sign(diag(VarMatrix)))~=11 && wn<10
for i=1:person     
        for s=1:SamNo           
            %%% Importance sampling of theta and u_random.
%             thetaSE=reshape(theta_se(i,:),time*domain,time*domain); %COVARIANCE matrix
            thetaSE=diag(theta_se(i,:).^2); %COVARIANCE matrix
            V_u_random=inv(T'*new_sigma^(-1)*eye(td)*T+inv(new_TAU)); %(2*domain)*(2*domain)
            M_u_random=V_u_random*T'*new_sigma^(-1)*eye(td)*(sam_theta(i,:)'-T*new_beta); %(2*domain)*1
            [r_u,p_u]=chol(V_u_random);
            V_u_random=r_u'*r_u;
            sam_u_random(:,i)=mvnrnd(M_u_random,V_u_random)';
            %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
            V_theta=inv(new_sigma^(-1)*eye(td)+inv(thetaSE)); %(domain*time)*(domain*time)
            M_theta=V_theta*(inv(thetaSE)*theta_mean(i,:)'+new_sigma^(-1)*eye(td)*(T*new_beta+T*sam_u_random(:,i))); %(domain*time)*1
            [r_theta,p_theta]=chol(V_theta);
            V_theta=r_theta'*r_theta;
            sam_theta(i,:)=mvnrnd(M_theta,V_theta);
                        
            D1_beta=D1_beta+D1BETA(sam_theta(i,:),sam_u_random(:,i));
            D1_sigma=D1_sigma+D1SIGMA(sam_theta(i,:),sam_u_random(:,i));
            D1_tau1=D1_tau1+D1TAU1(sam_theta(i,:),sam_u_random(:,i));
            D1_tau2=D1_tau2+D1TAU2(sam_theta(i,:),sam_u_random(:,i));
            D1_tau3=D1_tau3+D1TAU3(sam_theta(i,:),sam_u_random(:,i));
            D1_tau4=D1_tau4+D1TAU4(sam_theta(i,:),sam_u_random(:,i));
            D1_tau5=D1_tau25D1TAU5(sam_theta(i,:),sam_u_random(:,i));
            D1_tau6=D1_tau6+D1TAU6(sam_theta(i,:),sam_u_random(:,i));
            
            D2_beta=D2_beta+D2BETA(sam_theta(i,:),sam_u_random(:,i));
            D2_sigma=D2_sigma+D2SIGMA(sam_theta(i,:),sam_u_random(:,i));
            D2_bs=D2_bs+D2BS(sam_theta(i,:),sam_u_random(:,i));
            D2_tau11=D2_tau11+D2TAU11(sam_theta(i,:),sam_u_random(:,i));
            D2_tau22=D2_tau22+D2TAU22(sam_theta(i,:),sam_u_random(:,i));
            D2_tau33=D2_tau33+D2TAU33(sam_theta(i,:),sam_u_random(:,i));
            D2_tau12=D2_tau12+D2TAU12(sam_theta(i,:),sam_u_random(:,i));
            D2_tau13=D2_tau13+D2TAU13(sam_theta(i,:),sam_u_random(:,i));
            D2_tau23=D2_tau23+D2TAU23(sam_theta(i,:),sam_u_random(:,i));
            D2_tau44=D2_tau44+D2TAU44(sam_theta(i,:),sam_u_random(:,i));
            D2_tau55=D2_tau55+D2TAU55(sam_theta(i,:),sam_u_random(:,i));
            D2_tau66=D2_tau66+D2TAU66(sam_theta(i,:),sam_u_random(:,i));
            D2_tau45=D2_tau45+D2TAU45(sam_theta(i,:),sam_u_random(:,i));
            D2_tau46=D2_tau46+D2TAU46(sam_theta(i,:),sam_u_random(:,i));
            D2_tau56=D2_tau56+D2TAU56(sam_theta(i,:),sam_u_random(:,i));
            D2_bt1=D2_bt1+D2BT1(sam_theta(i,:),sam_u_random(:,i));
            D2_bt2=D2_bt2+D2BT2(sam_theta(i,:),sam_u_random(:,i));
            D2_bt3=D2_bt3+D2BT3(sam_theta(i,:),sam_u_random(:,i));
            D2_bt4=D2_bt4+D2BT4(sam_theta(i,:),sam_u_random(:,i));
            D2_bt5=D2_bt5+D2BT5(sam_theta(i,:),sam_u_random(:,i));
            D2_bt6=D2_bt6+D2BT6(sam_theta(i,:),sam_u_random(:,i));
            D2_st1=D2_st1+D2ST1(sam_theta(i,:),sam_u_random(:,i));
            D2_st2=D2_st2+D2ST2(sam_theta(i,:),sam_u_random(:,i));
            D2_st3=D2_st3+D2ST3(sam_theta(i,:),sam_u_random(:,i));
            D2_st4=D2_st4+D2ST4(sam_theta(i,:),sam_u_random(:,i));
            D2_st5=D2_st5+D2ST5(sam_theta(i,:),sam_u_random(:,i));
            D2_st6=D2_st6+D2ST6(sam_theta(i,:),sam_u_random(:,i));
        end        
end
FisherM_part1=zeros(11,11);
FisherM_part1(1:4,1:4)=D2_beta;
FisherM_part1(3,1:4)=D2_bs;
FisherM_part1(1:4,3)=D2_bs';
FisherM_part1(1:4,6:11)=[D2_bt1' D2_bt2' D2_bt3' D2_bt4' D2_bt5' D2_bt6'];
FisherM_part1(6:11,1:4)=[D2_bt1;D2_bt2;D2_bt3; D2_bt4;D2_bt5;D2_bt6];
FisherM_part1(5,5)=D2_sigma;
FisherM_part1(5,6:11)=[D2_st1 D2_st2 D2_st3 D2_st4 D2_st5 D2_st6];
FisherM_part1(6:11,5)=[D2_st1;D2_st2;D2_st3;D2_st4;D2_st5;D2_st6];
FisherM_part1(6,6:8)=[D2_tau11 D2_tau12 D2_tau13];
FisherM_part1(6:8,6)=[D2_tau11;D2_tau12;D2_tau13];
FisherM_part1(7,6:8)=[D2_tau12 D2_tau22 D2_tau23];
FisherM_part1(6:8,7)=[D2_tau12;D2_tau22;D2_tau23];
FisherM_part1(8,6:8)=[D2_tau13 D2_tau23 D2_tau33];
FisherM_part1(6:8,8)=[D2_tau13;D2_tau23;D2_tau33];
FisherM_part1(9,9:11)=[D2_tau44 D2_tau45 D2_tau46];
FisherM_part1(9:11,9)=[D2_tau44;D2_tau45;D2_tau46];
FisherM_part1(10,9:11)=[D2_tau45 D2_tau55 D2_tau56];
FisherM_part1(9:11,10)=[D2_tau45;D2_tau55;D2_tau56];
FisherM_part1(11,9:11)=[D2_tau46 D2_tau56 D2_tau66];
FisherM_part1(9:11,11)=[D2_tau46;D2_tau56;D2_tau66];

FisherM_part2=[D1_beta D1_sigma D1_tau1 D1_tau2 D1_tau3 D1_tau4 D1_tau5 D1_tau6];  %1*6

FisherM=FisherM_part1/SamNo-FisherM_part2*FisherM_part2'/(SamNo^2);
VarMatrix=inv(-FisherM);
wn=wn+1;
end
Ese=sqrt(diag(VarMatrix));
        



        
        
