#load foreign:
if (tryCatch(require("foreign")) == FALSE){
  install.packages("foreign")
  library(foreign)
}
#load lavaan:
if (tryCatch(require("lavaan")) == FALSE){
  install.packages("lavaan")
  library(lavaan)
}

current_dir = "C:/Users/zhan4787/Desktop/code/IES MIRT"
setwd(current_dir)

sd<-read.table("Mcovdis.txt")
mean<-read.table("Mmeandis.txt")

time<-4
person<-200
domain<-2
crime.model4 <- '
# intercept
i1 =~ 1*Time1d1 + 1*Time2d1 + 1*Time3d1 + 1*Time4d1
i2 =~ 1*Time1d2 + 1*Time2d2 + 1*Time3d2 + 1*Time4d2
# slope
s1 =~ 0*Time1d1 + 1*Time2d1 + 2*Time3d1 + 3*Time4d1
s2 =~ 0*Time1d2 + 1*Time2d2 + 2*Time3d2 + 3*Time4d2
# residual variances
Time1d1~~r*Time1d1
Time2d1~~r*Time2d1
Time3d1~~r*Time3d1
Time4d1~~r*Time4d1
Time1d2~~r*Time1d2
Time2d2~~r*Time2d2
Time3d2~~r*Time3d2
Time4d2~~r*Time4d2
#i1~~m*i2
#s1~~n*s2
'
#r<-1
#rep<-1
#sd<-read.table("TRUEcov.txt") 
#mean<-matrix(c(0,0,0.15,0.15,0.3,0.3,0.45,0.45),nrow = 1,ncol = 8)


rep<-50
eTAU<-matrix(100,rep,10)
eTAUse<-matrix(100,rep,10)
ebeta<-matrix(100,rep,4)
ebetase<-matrix(100,rep,4)
esigma<-matrix(100,rep,1)
esigmase<-matrix(100,rep,1)
for (r in 1:rep)
{
  # dataset 1
  crime.cov<-matrix(100,nrow = (domain*time),ncol = (domain*time))
  mean.temp<-t(mean[r,])
  crime.mean<-matrix(mean.temp,ncol = 1,nrow = (domain*time))
  crime.cov<-apply(matrix(sd[r,],nrow = (domain*time),ncol = (domain*time)),2,as.numeric)
  
  rownames(crime.mean)<- c("Time1d1","Time1d2", "Time2d1", "Time2d2", "Time3d1", "Time3d2", "Time4d1", "Time4d2")
  colnames(crime.cov) <- rownames(crime.cov) <- c("Time1d1","Time1d2", "Time2d1", "Time2d2", "Time3d1", "Time3d2", "Time4d1", "Time4d2")
  crime.fit4 <- growth(crime.model4, sample.cov=crime.cov, sample.mean=crime.mean, sample.nobs=person)
  #summary(crime.fit4,standardized=TRUE, fit.measures=TRUE)
  est<-parameterEstimates(crime.fit4)
  TAU<-matrix(100,nrow = 1,ncol = 10)
  TAU[1,1]<-est[25,5]
  TAU[1,2:4]<-t(est[29:31,5])
  TAU[1,5]<-est[26,5]
  TAU[1,6:7]<-t(est[32:33,5])
  TAU[1,8]<-est[27,5]
  TAU[1,9]<-est[34,5]
  TAU[1,10]<-est[28,5]

  TAUse<-matrix(100,nrow = 1,ncol = 10)
  TAUse[1,1]<-est[25,6]
  TAUse[1,2:4]<-t(est[29:31,6])
  TAUse[1,5]<-est[26,6]
  TAUse[1,6:7]<-t(est[32:33,6])
  TAUse[1,8]<-est[27,6]
  TAUse[1,9]<-est[34,6]
  TAUse[1,10]<-est[28,6]
  beta<-matrix(100,nrow = 1,ncol = 4)
  beta<-t(est[43:46,5])
  betase<-matrix(100,nrow = 1,ncol = 4)
  betase<-t(est[43:46,6])
  sigma<-est[17,5]
  sigmase<-est[17,6]
  eTAU[r,]<-TAU
  eTAUse[r,]<-TAUse
  ebeta[r,]<-beta
  ebetase[r,]<-betase
  esigma[r]<-sigma
  esigmase[r]<-sigmase
}

setwd(current_dir)
save.image("Mdis.RData")
colMeans(ebetase)
mean(esigmase)
colMeans(eTAUse)
#######################################
##### relative bias of SE      ########
betasd<-matrix(c(sd(ebeta[,1]),sd(ebeta[,2]),sd(ebeta[,3]),sd(ebeta[,4])),nrow = 1,ncol = 4)
colMeans(ebetase-matrix(1,rep,1)%*%betasd)
colMeans((ebetase-matrix(1,rep,1)%*%betasd)/(matrix(1,rep,1)%*%betasd))
sigmasd<-sd(esigma)
mean(esigmase-sigmasd)
mean((esigmase-sigmasd)/sigmasd)
TAUsd<-matrix(c(sd(eTAU[,1]),sd(eTAU[,2]),sd(eTAU[,3]),sd(eTAU[,4]),sd(eTAU[,5]),sd(eTAU[,6]),sd(eTAU[,7]),sd(eTAU[,8]),sd(eTAU[,9]),sd(eTAU[,10])),nrow = 1,ncol = 10)
colMeans(eTAUse-matrix(1,rep,1)%*%TAUsd)
colMeans((eTAUse-matrix(1,rep,1)%*%TAUsd)/(matrix(1,rep,1)%*%TAUsd))
#######################################
beta<-matrix(c(0,0,0.15,0.15),nrow = 1,ncol = 4)
sqrt(colMeans((ebeta-matrix(1,rep,1)%*%beta)^2))
colMeans(ebeta-matrix(1,rep,1)%*%beta)
colMeans((ebeta-matrix(1,rep,1)%*%beta)/(matrix(1,rep,1)%*%beta))
sqrt(mean((esigma-0.15)^2))
mean(esigma-0.15)
mean((esigma-0.15)/0.15)
TAU<-matrix(c(0.2, 0.1, 0, 0, 0.2, 0, 0, 0.2, 0.1, 0.2),nrow = 1,ncol = 10)
#TAU<-matrix(c(0.1,0.025,0.05),nrow = 1,ncol = 3)
sqrt(colMeans((eTAU-matrix(1,rep,1)%*%TAU)^2))
colMeans(eTAU-matrix(1,rep,1)%*%TAU)
colMeans((eTAU-matrix(1,rep,1)%*%TAU)/(matrix(1,rep,1)%*%TAU))