#load mvtnorm:
if (tryCatch(require("mvtnorm")) == FALSE){
  install.packages("mvtnorm")
  library(mvtnorm)
}
#load nlme:
if (tryCatch(require("nlme")) == FALSE){
  install.packages("nlme")
  library(nlme)
}
#load numDeriv:
if (tryCatch(require("numDeriv")) == FALSE){
  install.packages("numDeriv")
  library(numDeriv)
}

current_dir = "C:/Users/zhan4787/Desktop/code/IES MIRT"
setwd(current_dir)

TT<-4
D<-2
N<-200
P <- 2      # num of fixed effects
K <- 2      # num of random effects
sd<-read.table("MsethM.txt")
mean<-read.table("MmeanthM.txt")
true_sigma.sq <- 0.15                     # risidual variance
true_beta <- c(0,0,0.15,0.15)                    # mean of fixed effects
#true_sig_b.vec <- c(0.20,0.05,0.05,0.10)  # cov matrix of random effects
true_sig_b.vec <- c(0.2,0.1,0.1,0.2)  # cov matrix of random effects

### true.vect
true_sig_b<-matrix(0,nrow = (K*D),ncol = (K*D))
true_sig_b[1:D,1:D] <- matrix(true_sig_b.vec,D,D)  # cov matrix of random effects
true_sig_b[(D+1):(2*D),(D+1):(2*D)] <- matrix(true_sig_b.vec,D,D)  # cov matrix of random effects
## By rewrite the covariance matrix into var of intercept, slope, and 
## their correlation, the positive definite property can be maintained
## in the optimization.
true_sigma_b10 <- sqrt(true_sig_b.vec[1])
true_sigma_b11 <- sqrt(true_sig_b.vec[4])
true_rho1 <- true_sig_b.vec[2]/true_sigma_b10/true_sigma_b11
true_sigma_b20 <- sqrt(true_sig_b.vec[1])
true_sigma_b21 <- sqrt(true_sig_b.vec[4])
true_rho2 <- true_sig_b.vec[2]/true_sigma_b20/true_sigma_b21
# true values (to compute the RMSE and Bias)
true_vec <- c(true_beta,true_sigma_b10,true_sigma_b11,true_rho1,
              true_sigma_b20,true_sigma_b21,true_rho2,true_sigma.sq,
              true_sig_b.vec[1],true_sig_b.vec[4],true_sig_b.vec[2],
              true_sig_b.vec[1],true_sig_b.vec[4],true_sig_b.vec[2])

# simulating design matrix of X, Z
X <-matrix(0,(D*TT),(D*P)) 
Z <-matrix(0,(D*TT),(D*P)) 
for (t in 1:TT)
{
  X[((t-1)*D+1):(t*D),1:D]<-diag(D)
  X[((t-1)*D+1):(t*D),(1+D):(2*D)]<-(t-1)*diag(D)
  Z[((t-1)*D+1):(t*D),1:D]<-diag(D)
  Z[((t-1)*D+1):(t*D),(1+D):(2*D)]<-(t-1)*diag(D)
}


rep<-50
covariance<-matrix(100,rep,11)
est.mat <- matrix(100, nrow = rep, ncol = 17)    # store estimates
SE.mat <- matrix(100, nrow = rep, ncol = 17)     # store (est - true)^2
bias.mat <- matrix(100, nrow = rep, ncol = 17)   # store bias: (est - true)
colnames(est.mat) <- c("beta10","beta20","beta11","beta21",
                       "sigma_b10","sigma_b11","rho1","sigma_b20","sigma_b21","rho2",
                       "sigma.sq","tau100","tau111","tau101","tau200","tau211","tau201")
colnames(SE.mat) <- c("beta10","beta20","beta11","beta21",
                      "sigma_b10","sigma_b11","rho1","sigma_b20","sigma_b21","rho2",
                      "sigma.sq","tau100","tau111","tau101","tau200","tau211","tau201")
colnames(bias.mat) <- c("beta10","beta20","beta11","beta21",
                        "sigma_b10","sigma_b11","rho1","sigma_b20","sigma_b21","rho2",
                        "sigma.sq","tau100","tau111","tau101","tau200","tau211","tau201")
out <- list()

for (r in 1:rep)
{
  ########################################
  ###Input the estimations from Stage1 ###
  sd0<-as.numeric(sd[r,]^2)
  mean0<-as.numeric(mean[r,])
  theta_star<-matrix(mean0,ncol = (TT*D),nrow = N)
  var.EAP.mat<-matrix(sd0,ncol = (TT*D),nrow = N)
  ########################################
  
  Sigma_theta <- array(NA,dim=c((TT*D),(TT*D),N))
  for (i in 1:N){ Sigma_theta[,,i] <- diag(var.EAP.mat[i,]) }
  Sigma_theta_inv <- array(NA,dim=c((TT*D),(TT*D),N))
  for (i in 1:N){ Sigma_theta_inv[,,i] <- solve(Sigma_theta[,,i]) }
  
  ########################################
  ###Likelihood function using optim   ###
  logL <- function(x){
    # copy some values
    beta_vec <- x[1:(P*D)]
    Sigma_b_mat <- matrix(0,nrow = (K*D),ncol = (K*D))
    Sigma_b_mat[1,1]<-x[(P*D)+1]^2
    Sigma_b_mat[1,2]<-x[(P*D)+1]*x[(P*D)+2]*x[(P*D)+3]
    Sigma_b_mat[2,1]<-x[(P*D)+1]*x[(P*D)+2]*x[(P*D)+3]
    Sigma_b_mat[2,2]<-x[(P*D)+2]^2
    Sigma_b_mat[3,3]<-x[(P*D)+4]^2
    Sigma_b_mat[3,4]<-x[(P*D)+4]*x[(P*D)+5]*x[(P*D)+6]
    Sigma_b_mat[4,3]<-x[(P*D)+4]*x[(P*D)+5]*x[(P*D)+6]
    Sigma_b_mat[4,4]<-x[(P*D)+5]^2
    sigma.sq <- x[length(x)]
    sigma.sq.mat_inv<-(1/sigma.sq)*diag(TT*D)
    
    ## temp_mat is sigma.sq^2*Sigma_theta^{-1}+I_i
    temp_mat <- array(0,dim=c((TT*D),(TT*D),N))
    for (i in 1:N){ temp_mat[,,i] <- Sigma_theta_inv[,,i] + sigma.sq.mat_inv }
    ## the inverse of temp_mat
    temp_mat_inv <- array(0,dim=c((TT*D),(TT*D),N))
    for (i in 1:N){ temp_mat_inv[,,i] <- solve(temp_mat[,,i]) }
    
    Sigma_b_star_inv <- array(0,dim=c((K*D),(K*D),N))
    for (i in 1:N){
      Sigma_b_star_inv[,,i] <- solve(Sigma_b_mat) + t(Z)%*%sigma.sq.mat_inv%*%Z - t(Z)%*%sigma.sq.mat_inv%*%temp_mat_inv[,,i]%*%sigma.sq.mat_inv%*%Z
    }
    
    Sigma_b_star <- array(0,dim=c((K*D),(K*D),N))
    for (i in 1:N){ Sigma_b_star[,,i] <- solve(Sigma_b_star_inv[,,i]) }
    
    temp_mat2 <- matrix(0, ncol = N, nrow = (TT*D))
    for (i in 1:N){
      temp_mat2[,i]<-crossprod(Sigma_theta_inv[,,i],theta_star[i,]) + sigma.sq.mat_inv %*% X%*%beta_vec
    }
    
    mu_b_star <- matrix(0,N,(K*D))
    for (i in 1:N){
      mu_b_star[i,] <-t(Z)%*%sigma.sq.mat_inv%*%(X %*% beta_vec) - t(Z)%*%temp_mat_inv[,,i]%*%sigma.sq.mat_inv%*% temp_mat2[,i] 
    }
    
    temp_sqrt1 <- array(0, dim = c((TT*D),(TT*D),N))
    for (i in 1:N){
      temp.eig <- eigen(solve(temp_mat[,,i]))
      temp_sqrt1[,,i] <- temp.eig$vectors %*%  diag(sqrt(temp.eig$values)) %*% solve(temp.eig$vectors)
    }
    temp_sqrt2 <- array(NA, dim = c((K*D),(K*D),N))
    for (i in 1:N){
      temp.eig2 <- eigen(Sigma_b_star[,,i])
      temp_sqrt2[,,i] <- temp.eig2$vectors %*% diag(sqrt(temp.eig2$values)) %*% solve(temp.eig2$vectors)
    }
    
    temp_norm1 <- numeric(N)
    for (i in 1:N){
      temp_norm1[i] <- sum((temp_sqrt1[,,i] %*% temp_mat2[,i])^2)
    }
    temp_norm2 <- numeric(N)
    for (i in 1:N){
      temp_norm2[i] <- sum((mu_b_star[i,]%*%temp_sqrt2[,,i])^2)
    }
    
    # Objective function
    obj <- -N*log(det(Sigma_b_mat)) + N*log(det(sigma.sq.mat_inv))- 
      sum(log(apply(temp_mat,3,det)))+ 
      sum(log(apply(Sigma_b_star, 3, det)))- 
      N * t(X%*%beta_vec)%*%sigma.sq.mat_inv%*% (X%*%beta_vec)  +
      sum(temp_norm1) + 
      sum(temp_norm2)
    return(-obj)
  }
  ########################################
  
 
  
  
  ########################################
  ###Estimate parameters using optim   ###
  x_int <- rep(0.1,11)   #initial values of unknown parameters
  temp <-  optim(x_int,logL, method= "L-BFGS-B", 
                 upper = c(1e3,1e3,1e3,1e3,5,5,0.99,5,5,0.99,1e3),
                 lower = c(-1e3,-1e3,-1e3,-1e3,1e-3,1e-3,-0.99,1e-3,1e-3,-0.99,1e-3),hessian = TRUE)
  covariance[r,]<-sqrt(diag(solve(temp$hessian)))
  ########################################
  
  est.mat[r,] <- c(temp$par,temp$par[5]^2,temp$par[6]^2,temp$par[5]*temp$par[6]*temp$par[7],temp$par[8]^2,temp$par[9]^2,temp$par[8]*temp$par[9]*temp$par[10])
  SE.mat[r,] <- (est.mat[r,]-true_vec)^2
  bias.mat[r,] <- est.mat[r,]-true_vec
  
}
out$est.mat <- est.mat
out$SE.mat <- SE.mat
out$bias.mat <- bias.mat

meanse<-colMeans(covariance)
meanbias<-colMeans(out$bias.mat)
meanrmse<-colMeans(sqrt(out$SE.mat))
setwd(current_dir)
save.image("MAP200CmM.RData")
#######################################
##### standard error estimates ########
colMeans(covariance)  #1:4 & end
varpart0<-covariance[,5:7]
estpart0<-out$est.mat[,5:7]

varpart1<-covariance[,8:10]
estpart1<-out$est.mat[,8:10]

Est.se<-matrix(100,50,11)
Est.se[,1:4]<-covariance[,1:4]
Est.se[,5]<-covariance[,11]
Est.se[,6]<-2*estpart0[,1]*varpart0[,1]
Est.se[,7]<-sqrt((estpart0[,1]*estpart0[,2]*varpart0[,3])^2+(estpart0[,1]*estpart0[,3]*varpart0[,2])^2+(estpart0[,3]*estpart0[,2]*varpart0[,1])^2)
Est.se[,8]<-2*estpart0[,2]*varpart0[,2]
Est.se[,9]<-2*estpart1[,1]*varpart1[,1]
Est.se[,10]<-sqrt((estpart1[,1]*estpart1[,2]*varpart1[,3])^2+(estpart1[,1]*estpart1[,3]*varpart1[,2])^2+(estpart1[,3]*estpart1[,2]*varpart1[,1])^2)
Est.se[,11]<-2*estpart1[,2]*varpart1[,2]
colnames(Est.se)<-c("beta10","beta20","beta11","beta21","sigma.sq","tau100","tau101","tau111","tau200","tau201","tau211")
colMeans(Est.se)
#######################################
Est.par<-matrix(100,50,11)
Est.par<-est.mat[,c(1:4,11,12,14,13,15,17,16)]
#######################################
##### relative bias of SE      ########
True.sd<-matrix(100,1,11)
for (s in 1:11) {True.sd[1,s]<-sd(Est.par[,s])}

colMeans(Est.se-matrix(1,50,1)%*%True.sd)
colMeans((Est.se-matrix(1,50,1)%*%True.sd)/(matrix(1,50,1)%*%True.sd))
#######################################

#######################################
##### bias & relative bias     ########
True.par<-matrix(c(0,0,0.15,0.15,0.15,0.2,0.1,0.2,0.2,0.1,0.2),1,11)
colMeans(Est.par-matrix(1,50,1)%*%True.par)
colMeans((Est.par-matrix(1,50,1)%*%True.par)/(matrix(1,50,1)%*%True.par))
