clc
clear 
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%  IES project for MIRT Models            %%%
%%%  Number of measurement waves:4          %%%
%%%  Item parametets are fixed as known.    %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
delete(gcp)
parpool(25) % the number of nodes used to parallel analysis

person=2000;   %sample size
time=4;       %number of measurement waves
domain=2;     %number of dimensions 
J=10;
for d=1:domain
    Dind(d,(d-1)*J+1:d*J)=ones(1,J);  % indicator of dimension
end
clear d
item=J*domain; 
PamNo=3;
TAU=[0.2 0.1 0 0 ;0.1 0.2 0 0; 0 0 0.2 0.1;0 0 0.1 0.2];
D=1.7;

rep=50;  % The number of replications.
ntimeL=70;  % The upper number of iterations of likelihood method (EM/MLE).  
ntime=10000; burnin=ntime/2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
realPI=100*ones(rep,person*2*domain);
EbetaMC=100*ones(4,rep); EsigmaMC=100*ones(1,rep); ETAUMC=100*ones(rep,16);
SE_beta=100*ones(4,rep);SE_sigma=100*ones(1,rep);SE_TAU=100*ones(rep,16);
RMSEthMC=100*ones(time,rep); BIASthMC=100*ones(time,rep);
MEANdis=100*ones(rep,time*domain); COVdis=100*ones(rep,(time*domain)^2);
RMSEthL=100*ones(time*domain,rep); BIASthL=100*ones(time*domain,rep);MEANthL=100*ones(rep,person*time*domain);SEthL=100*ones(rep,person*time*domain);
EbetaEML=100*ones(4,rep); EsigmaEML=100*ones(1,rep); ETAUEML=100*ones(rep,16); EnEML=100*ones(1,rep);ESEEML=100*ones(11,rep);
EbetaMLEL=100*ones(4,rep); EsigmaMLEL=100*ones(1,rep); ETAUMLEL=100*ones(rep,16); EnMLEL=100*ones(1,rep);ESEMLEL=100*ones(11,rep);
parfor r=1:rep
    [a,b,c,u,theta,beta,T,PI]=simulation_Multivariate(person,item,domain,time,Dind,TAU,PamNo);
    realPI(r,:)=PI(1:end);
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%% Stage 1: MLE
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    response=100*ones(person,domain*time);
    for t=1:time
        for j=1:item
            response(:,j+(t-1)*item)=u(:,j,t);
        end
    end
    theta_est=zeros(person, domain*time);
    se_est=zeros(person, domain*time);
    
    for t=1:time
        for i=1:person
            for k=1:domain
                extract=((k-1)*J+1):k*J;
                temporary=MLE_theta(0,1:J,response(i,((t-1)*domain*J+(k-1)*J+1):((t-1)*domain*J+k*J)),J,a(k,extract,t)',b(t,extract)',c(t,extract)',1.7,0.005);            
                A=a(k,extract,t)';B=b(t,extract)';C=c(t,extract)';
                D2try=0;
                for j=1:J               
                    Prob=ICF_Computation(temporary,A(j),B(j),C(j),1.7);
                    D2try=D2try+D^2*(A(j))^2*(1-Prob)*(Prob-C(j))^2/((1-C(j))^2*Prob);
                end
                se_est(i,(t-1)*domain+k)=1/sqrt(D2try);
                if (abs(temporary)==3)
                    temporary=MAP_theta(0,1:J,response(i,((t-1)*domain*J+(k-1)*J+1):((t-1)*domain*J+k*J)),J,a(k,extract,t)',b(t,extract)',c(t,extract)',1.7,0.005,0,5);
                    A=a(k,extract,t)';B=b(t,extract)';C=c(t,extract)';
                    D2try=0;
                    for j=1:J               
                        Prob=ICF_Computation(temporary,A(j),B(j),C(j),1.7);
                        D2try=D2try+D^2*(A(j))^2*(1-Prob)*(Prob-C(j))^2/((1-C(j))^2*Prob);
                    end
                    D2try=D2try+5;
                    se_est(i,(t-1)*domain+k)=1/sqrt(D2try);
                end
                theta_est(i,(t-1)*domain+k)=temporary;
            end
        end
    end    
    rmse_thL=sqrt(mean((theta_est-theta).^2));
    bias_thL=mean(theta_est-theta);
    RMSEthL(:,r)=rmse_thL;
    BIASthL(:,r)=bias_thL;
    
    MEANthL(r,:)=theta_est(1:end);
    SEthL(r,:)=se_est(1:end);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%% Stage 2: MCEM or MCMLE
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    sethL=se_est; ethL=theta_est;
    [EEbetaEML,EEsigmaEML,EETAUEML,EseEML,noEML]=MCEM_Mies(T,sethL,ethL,domain,ntimeL);
    EbetaEML(:,r)=EEbetaEML;
    EsigmaEML(r)=EEsigmaEML;
    ETAUEML(r,:)=EETAUEML(1:end);
    ESEEML(:,r)=EseEML;
    EnEML(r)=noEML;
    
    [EEbetaMLEL,EEsigmaMLEL,EETAUMLEL,EseMLEL,noMLEL]=MCMLE_Mies(T,sethL,ethL,domain,ntimeL);
    EbetaMLEL(:,r)=EEbetaMLEL;
    EsigmaMLEL(r)=EEsigmaMLEL;
    ETAUMLEL(r,:)=EETAUMLEL(1:end);
    ESEMLEL(:,r)=EseMLEL;
    EnMLEL(r)=noMLEL;
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%% MCMC
    [rbeta,rTAU,rsigma,rPI,rth]=MCMC_MPLFIX(u,T,ntime,b,a,c);
    ethMC=mean(rth(:,:,burnin+1:end),3);
    rmse_thMC=sqrt(mean((ethMC-theta).^2,1));
    bias_thMC=mean(ethMC-theta,1);
    RMSEthMC(r,:)=rmse_thMC;
    BIASthMC(r,:)=bias_thMC;
    ebetaMC=mean(rbeta(:,burnin+1:end),2);
    esigmaMC=mean(rsigma(burnin+1:end));
    eTAUMC=mean(rTAU(burnin+1:end,:),1);
    EbetaMC(:,r)=ebetaMC;
    EsigmaMC(r)=esigmaMC;
    ETAUMC(r,:)=eTAUMC;
    SE_beta(:,r)=sqrt(mean((rbeta(:,burnin+1:end)-ebetaMC*ones(1,ntime/2)).^2,2));
    SE_sigma(r)=sqrt(mean((rsigma(burnin+1:end)-esigmaMC).^2));
    SE_TAU(r,:)=sqrt(mean((rTAU(burnin+1:end,:)-ones(ntime/2,1)*eTAUMC).^2));
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% Estimate the parameters using EM+ REML algorithm.        %%%
    [mean_theta,cov_theta,noDIS]=EMdis_M(u,ntimeL,a,b,c);
    MEANdis(r,:)=mean_theta;
    COVdis(r,:)=cov_theta(1:end);    
            
  
end
save MT4Em

save MmeanthLEm.txt MEANthL -ascii
save MsethLEm.txt SEthL -ascii
save MrealPILEm.txt realPI -ascii
toc
