function [rth]=mh_partMFIX(u,PI,T,sigma,theta,b,a,c) 
% This function is used to estimate the examinee ability in longitudinal IRT model 
%(IRT with LGC) using MH algorithm when item parameters are fixed.
[person,item,time]=size(u);
domain=size(a,1);
J=item/domain;
for d=1:domain
    Dind(d,(d-1)*J+1:d*J)=ones(1,J);  % indicator of dimension
end
clear d
% FUNCTION HANDLE FOR 2PL & 3PL MODELS.
D=1.7;
P=@(th,a,b,c) kron(ones(person,1),c)+(1-kron(ones(person,1),c))./(1+exp(-D*th*a+D*kron(ones(person,1),sum(a.*(ones(domain,1)*b)))));  %person*item

if nargin<8
    c=zeros(time,item);
end

for t=1:time
    u0=u(:,:,t);  %person*item
    for d=1:domain
        th0(:,d)=theta(:,(t-1)*domain+d);  %person*domain
    end
    clear d
    a0=a(:,:,t); %domain*item
    b0=b(t,:);c0=c(t,:);
    %%%%%%%%%% sampling theta %%%%%%%%%%%%%%%%
    th_star=normrnd(th0,0.8);    %0.8
    sth=unifrnd(0,1,person,domain);
    pth=P(th0,a0,b0,c0);    %person*item
    pth_star=P(th_star,a0,b0,c0);
    for d=1:domain
        T0(d,:)=T((d-1)*time+t,:);  % domain*(2domain)
        u0_temp=u0(:,(d-1)*J+1:d*J);
        likeli(:,d)=prod(pth_star(:,(d-1)*J+1:d*J).^u0_temp.*(1-pth_star(:,(d-1)*J+1:d*J)).^(1-u0_temp)./(pth(:,(d-1)*J+1:d*J).^u0_temp.*(1-pth(:,(d-1)*J+1:d*J)).^(1-u0_temp)),2);
    end
    clear d
    alpha_th=likeli.*normpdf(th_star,PI*T0',sqrt(sigma))./normpdf(th0,PI*T0',sqrt(sigma));
    alpha_th=min(alpha_th,1);
    th0(find(sth<=alpha_th))=th_star(find(sth<=alpha_th));
    for d=1:domain
        theta_temp(:,(t-1)*domain+d)=th0(:,d);  %person*domain
    end
    clear d th0 T0
       
    rth=theta_temp;
end

