function [a,b,c,u,theta,beta,T,PI]=simulation_Multivariate(person,item,domain,time,Dind,TAU,PamNo)
% Dind is a indicator of multidimensional structure.
% The size of b(c) is time*item.
% The size of theta is person*(time*domain). D=1&[1-T] D=2&[1-T] D=3&[1-T]
% FUNCTION HANDLE FOR 2PL & 3PL MODELS.
d=1.7;
P3=@(th,a,b,c) kron(ones(person,1),c)+(1-kron(ones(person,1),c))./(1+exp(-d*th*a+d*ones(size(th))*(a.*kron(ones(domain,1),b))));
% P3=@(th,a,b,c) kron(ones(person,1),c)+(1-kron(ones(person,1),c))./(1+exp(-d*th*a+d*kron(ones(person,1),b)));  %person*item
T=[eye(domain) 0*eye(domain);eye(domain) eye(domain);eye(domain) 2*eye(domain);eye(domain) 3*eye(domain)];

beta=ones(domain,1)*[0;0.15]';
beta=beta(1:end)';  %(2domain)*1
% kron(ones(domain,1),[0;0.15]);
betaPerson=ones(person,1)*beta';
PI=mvnrnd(betaPerson,TAU); %person*(2domain)
sigma=kron(0.15*ones(1,domain),ones(1,time));
% theta=mvnrnd(PI*T',diag(sigma));  %person*(time*domain)  T=1//T=2//T=3//T=4
theta=PI*T'+mvnrnd(zeros(person,time*domain),diag(sigma));  %person*(time*domain)  T=1//T=2//T=3//T=4
% ITEM PARAMETERS GENERATION
for t=1:time
    a(:,:,t)=unifrnd(1.5,2.5,domain,item).*Dind;   %domain*item*time
    for d=1:domain
        th(:,d,t)=theta(:,(t-1)*domain+d);   %person*domain*time
    end
end
for t=1:time
%     b(t,:)=normrnd(0.1*(t-1),1,1,item);
    b(t,:)=normrnd(mean(mean(theta(:,(t-1)*domain+1:t*domain),2)),1,1,item);
end
clear t
% b=normrnd(0,1,time,item);
if PamNo==3;
    c=unifrnd(0.1,0.2,time,item);
elseif PamNo==2;
    c=zeros(time,item);
end
for t=1:time
    thtemp=th(:,:,t);     %person*1
    atemp=a(:,:,t);
    p=P3(thtemp,atemp,b(t,:),c(t,:));
    u(:,:,t)=binornd(1,p);
end
